Subject: [ietf-tls] Re: Re: London

From: Bodo Moeller <[email-masked]>
Date: Mon, 16 Jul 2001 10:39:37 +0200

On Mon, Jul 16, 2001 at 02:13:27AM +1200, Peter Gutmann wrote:

>> TLS extensions can only be used in SSL 3.0 and TLS 1.0 ClientHello messages,
>> not in SSL 2.0 CLIENT-HELLO messages.  While it is time to give up the actual
>> SSL 2.0 protocol, the SSL 2.0 CLIENT-HELLO format still play an important role
>> for protocol version negotiation, and handshakes usually start using this
>> format.

> Only Netscape does it, I've never seen IE start with v2 (in fact Netscape
> always sends a v2 hello no matter what you do, even with SSLv2 turned off).
> Given that IE doesn't send a v2 hello, I think it's safe to assume that
> everything can handle v3 hellos.

Last I checked (Windows 2000 Professional, IE 5.50.whatever), IE still
had SSL 2.0 support enabled by default, so it used the SSL 2.0
CLIENT-HELLO format.  If you disabled SSL 2.0 and enabled TLS 1.0 (the
latter was disabled by default), it did not use the SSL 3.0
ClientHello format as it should have done, but the TLS 1.0 ClientHello
format; that is, the record header contained a 'version' value of
{0x03, 0x01}, i.e. the 'client_version' value, while it should contain
{0x03, 0x00} for backwards compatibility.

With ClientHellos built like this, IE avoided the bug in servers that
use 'version' where they should use 'client_version' -- in those
ClientHellos, these two were the same value, after all.

Using the SSL 3.0 ClientHello format for backwards compatibility may
or may not work well in practice.  IE does not prove that it does.

-- 
Bodo Möller <[email-masked]>
PGP http://www.informatik.tu-darmstadt.de/TI/Mitarbeiter/moeller/0x36d2c658.html
* TU Darmstadt, Theoretische Informatik, Alexanderstr. 10, D-64283 Darmstadt
* Tel. +49-6151-16-6628, Fax +49-6151-16-6036

---
You are currently subscribed to ietf-tls as: [email-masked]
To unsubscribe send a blank email to [email-masked]